> ## Documentation Index
> Fetch the complete documentation index at: https://docs.campfire.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Contract Invoice



## OpenAPI

````yaml https://api.meetcampfire.com/api/schema?format=json post /rev/api/v1/invoices
openapi: 3.0.3
info:
  title: Campfire Developer APIs
  version: 1.0.0
  description: >
    ## Introduction

    Campfire's developer APIs offer granular access to Campfire's core
    accounting,

    revenue recognition, and financial data features.


    These APIs are designed to be used by developers to build custom
    integrations,

    automate workflows, and perform any other programmatic operations.


    ## Rate limits

    API users can make up to **5 requests per second**. This limit is shared
    across

    all endpoints for the same API user. Requests that exceed the limit receive
    a

    `429 Too Many Requests` response. Wait for the number of seconds specified
    in

    the `Retry-After` response header before retrying.
servers:
  - url: https://api.meetcampfire.com
    description: Production server
security: []
tags:
  - name: Cash Management
    description: Operations related to accounts, transactions, and other bank-related data.
  - name: Core Accounting
    description: >-
      Operations related to core accounting data, such as the chart of accounts,
      entity management, and the general ledger.
  - name: Revenue Recognition
    description: >-
      Operations related to revenue recognition, contract management, and
      contract data aggregation.
  - name: Accounts Receivable
    description: Operations related to invoicing and the AR subledger
  - name: Accounts Payable
    description: Operations related to billing and the AP subledger.
  - name: Financial Statements
    description: Operations related to financial statement generation and data aggregation.
  - name: Settings
    description: Operations related to system and accounting settings configuration.
paths:
  /rev/api/v1/invoices:
    post:
      tags:
        - Revenue
      summary: Create Contract Invoice
      operationId: rev_api_v1_invoices_create
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/RevenueContractInvoice'
          application/x-www-form-urlencoded:
            schema:
              $ref: '#/components/schemas/RevenueContractInvoice'
          multipart/form-data:
            schema:
              $ref: '#/components/schemas/RevenueContractInvoice'
        required: true
      responses:
        '201':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RevenueContractInvoice'
          description: ''
      security:
        - knoxApiToken: []
components:
  schemas:
    RevenueContractInvoice:
      type: object
      description: |-
        Base serializer that injects the request user's customer on create and
        restricts related-object querysets to the same customer.
      properties:
        id:
          type: integer
          readOnly: true
        contract:
          type: integer
        contract_name:
          type: string
          readOnly: true
        invoice_number:
          type: string
          maxLength: 255
        status:
          $ref: '#/components/schemas/RevenueContractInvoiceStatusEnum'
        issue_date:
          type: string
          format: date
        due_date:
          type: string
          format: date
          nullable: true
        bill_to_snapshot: {}
        currency:
          type: string
          maxLength: 3
        total_amount:
          type: number
          format: double
          maximum: 10000000000000
          minimum: -10000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
        lines:
          type: array
          items:
            $ref: '#/components/schemas/RevenueContractInvoiceLine'
          readOnly: true
        created_at:
          type: string
          format: date-time
          readOnly: true
        last_modified_at:
          type: string
          format: date-time
          readOnly: true
      required:
        - contract
        - contract_name
        - created_at
        - id
        - issue_date
        - last_modified_at
        - lines
    RevenueContractInvoiceStatusEnum:
      enum:
        - SCHEDULED
        - ISSUED
        - PAID
        - VOIDED
      type: string
      description: |-
        * `SCHEDULED` - Scheduled
        * `ISSUED` - Issued
        * `PAID` - Paid
        * `VOIDED` - Voided
    RevenueContractInvoiceLine:
      type: object
      description: |-
        Base serializer that injects the request user's customer on create and
        restricts related-object querysets to the same customer.
      properties:
        id:
          type: integer
          readOnly: true
        invoice:
          type: integer
        contract_line:
          type: integer
          nullable: true
        description:
          type: string
          maxLength: 500
        service_start:
          type: string
          format: date
          nullable: true
        service_end:
          type: string
          format: date
          nullable: true
        currency:
          type: string
          maxLength: 3
        amount:
          type: number
          format: double
          maximum: 10000000000000
          minimum: -10000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
        created_at:
          type: string
          format: date-time
          readOnly: true
        last_modified_at:
          type: string
          format: date-time
          readOnly: true
      required:
        - created_at
        - id
        - invoice
        - last_modified_at
  securitySchemes:
    knoxApiToken:
      type: apiKey
      in: header
      name: Authorization
      description: Token-based authentication with required prefix "Token"

````